/***************************************************************************
                          cthread.h  -  description
                             -------------------
    begin                : Sun Sep 30 2001
    copyright            : (C) 2001 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CTHREAD_H
#define CTHREAD_H

#include <dclib/dcos.h>
#include <pthread.h>
#include <dclib/cobject.h>

/**
  *@author Mathias Kster
  */

class DLL_EXPORT CThread {

public:
	CThread();
	virtual ~CThread();

	/** */
	int Start();
	/** */
	int Stop( bool bHard = 1 );
	/** */
	int Lock();
	/** */
	int UnLock();

	/** */
	virtual void Thread(CObject *) {};

private:
	/** */
	pthread_t thread;
	/** */
	pthread_mutex_t mutex;
	/** */
	int iStop;
	/** */
	int iRun;
	/** */
	static void * MainThread(void *object);
};

/** */
inline int CThread::Lock()
{ return pthread_mutex_lock(&mutex);};
/** */
inline int CThread::UnLock()
{ return pthread_mutex_unlock(&mutex);};

#endif
